function bode_asymp(varargin)
// Trace le diagramme de bode assymptotique & reel
// des systèmes passes en paramètres
// Syntaxe : TraceBode(sys1,'r',sys2,'b',...,Ep1,Ep2)
//    Ep1 : epaisseur de trace des assymptotes
//    Ep2 : epaisseur de trace de la courbe reelle
//	  tr_sys : 1 si trace du système reel	0 trace asymptotique seul

//petit bogue dans laversion de sev GainStat à remplacer 
//par GainStatique ao moment des traces

// système de test : 
//getf('tracebode.sci')
//G=syslin('c', poly([3 4],"s","coeff"), poly([1 2 2],"s","coeff"));
//G2=syslin('c', poly([3 4],"s","coeff"), poly([2 2 1],"s","coeff"));
//tracebode(G,'red',G2,'blue',1,3)

// Calcul du nombre de système à representer
NbSystemes=(length(varargin)-3)/2;
//disp('NbSystemes',NbSystemes);

Ep1=varargin(length(varargin)-3);
//disp('Ep1',Ep1);
Ep2=varargin(length(varargin)-2);
//disp('Ep2',Ep2);
tr_sys=varargin(length(varargin)-1);
//disp('tr_sys',tr_sys);
grid_x=varargin(length(varargin));
//disp('tr_sys',tr_sys);

TabSys=list();
TabCoul=list();
TabPoles=list();
TabNbInte=list();
TabZeros=list();
TabNbDeriv=list();

chaine='';
// Recherche des bornes min & max pour tous les systèmes
for kk=1:NbSystemes
   	sys=varargin(2*(kk-1)+1);
//	disp('sys',sys);
	Coul=varargin(2*(kk-1)+2);
	[lnum,lden,k]=factors(sys ,'c');
	sys_bis=(factors(sys ,'c'))/k;
//	disp('k',k);
//	disp('Gbis',sys_bis);
	z=roots(sys_bis.num);
	p=roots(sys_bis.den);
//	disp('z',z);
//	disp('p',p);
	GainStat=k;
   // Memorisation des donnees
   TabSys(kk)=sys;
   TabCoul(kk)=Coul;
   
   // Recherche des integrateurs
   indices=find(p==0);
   NbInte=length(indices);
   // Construction du tableau contenant les poles du système
   pp=[];
   for i=1:length(p)
      if p(i)~=0
         pp=[pp p(i)];
      end;
   end;
   TabPoles(kk)=pp;
//	disp('tabpoles', TabPoles(kk));
   TabNbInte(kk)=NbInte;
//  disp('tabinteg', TabNbInte(kk));

   // Recherche des derivateurs
   indices=find(z==0);
   NbDeriv=length(indices);
   // Construction du tableau contenant les zeros du système
   zz=[];
   for i=1:length(z)
      if z(i)~=0 then
         zz=[zz z(i)];
      end;
   end;
   TabZeros(kk)=zz;
//   disp('tabzeros', TabZeros(kk));
   TabNbDeriv(kk)=NbDeriv;
//   disp('tabderiv', TabNbDeriv(kk));

   // Calcul du gain statique du système
   GainStat=GainStat/prod(-pp);
   GainStat=GainStat*prod(-zz);
   TabGainStatique(kk)=GainStat;
//   disp('tabgain',TabGainStatique(kk));

   // Recherche des bornes
   if (~isempty(pp))&(isempty(zz)) then
       // Que des poles
       Wmin=min(abs(pp));
       Wmax=max(abs(pp));
   elseif (~isempty(zz))&(isempty(pp)) then
       // Que des zeros
       Wmin=min(abs(zz));
       Wmax=max(abs(zz));
   elseif (isempty(zz))&(isempty(pp)) then
       // Que des integrateurs ou des gains
       Wmin=1;
       Wmax=1;
   else
       // Poles et zeros
       Wmin=min(abs(max(abs(zz))),abs(max(abs(pp))));
       Wmax=max(abs(min(abs(zz))),abs(min(abs(pp))));
   end;
    
   // Arrondis à la puissance de 10
   WWmin(kk)=10^(floor(log10(Wmin))-2);
   WWmax(kk)=10^(ceil(log10(Wmax))+2);
end; // Fin du for kk=1:NbSystemes


Wmin=min(WWmin);
Wmax=max(WWmax);

for kk=1:NbSystemes
   pp=TabPoles(kk);
   zz=TabZeros(kk);
   sys=TabSys(kk);
   NbDeriv=TabNbDeriv(kk);
   NbInte=TabNbInte(kk);
   
   GainStatique=TabGainStatique(kk);
   Coul=TabCoul(kk);
   
   // ======================================================
   // Calcul de la courbe de gain assymptotique
   // ======================================================
   PenteGain=-NbInte+NbDeriv;
   FreqGain=[Wmin Wmax];

   // Prise en compte des poles
   for i=1:length(pp)
      j=1;
      while (FreqGain(j)<abs(pp(i)))&(j<length(FreqGain)) 
         j=j+1;
      end;
      
      FreqGain=[FreqGain(1:j-1) abs(pp(i)) FreqGain(j:length(FreqGain))];
      PenteGain=[PenteGain(1:j-1) PenteGain(j-1)-1 PenteGain(j:length(PenteGain))-1];
   end;
   
   // Prise en compte des zeros
   for i=1:length(zz)
      j=1;
      while (FreqGain(j)<abs(zz(i)))&(j<length(FreqGain)) 
         j=j+1;
      end;
      FreqGain=[FreqGain(1:j-1) abs(zz(i)) FreqGain(j:length(FreqGain))];
      PenteGain=[PenteGain(1:j-1) PenteGain(j-1)+1 PenteGain(j:length(PenteGain))+1];
   end;
   
   
   // ======================================================
   // Calcul de la courbe de phase assymptotique
   // ======================================================
   PentePhase=0;
   FreqPhase=[Wmin Wmax];
   
   // Prise en compte des poles
   for i=1:length(pp)
      j=1;
      
      while (FreqPhase(j)<abs(pp(i)/10))&(j<length(FreqPhase)) 
         j=j+1;
      end
      
      if FreqPhase(j)~=abs(pp(i)/10) then
         // Pole inexistant
         FreqPhase=[FreqPhase(1:j-1) abs(pp(i))/10 FreqPhase(j:length(FreqPhase))];
         if real(pp(i)) < 0 then
            // Pole stable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)-1 PentePhase(j:length(PentePhase))-1]; 
         else
            // Pole instable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)+1 PentePhase(j:length(PentePhase))-1]; 
         end
      else
         // Pole multiple : on ne rajoute pas de nouvelle cassure, on ne fait qu'augmenter la pente
         if real(pp(i)) < 0 then
            // Pole stable
            PentePhase=[PentePhase(1:j-1)  PentePhase(j:length(PentePhase))-1]; 
         else
            // Pole instable
            PentePhase=[PentePhase(1:j-1)  PentePhase(j:length(PentePhase))-1]; 
         end;
      end;
      
      j=1;
      while (FreqPhase(j)<abs(pp(i))*10)&(j<length(FreqPhase)) 
         j=j+1;
      end;
      if FreqPhase(j)~=abs(pp(i))*10
         // Pole inexistant
         
         FreqPhase=[FreqPhase(1:j-1) 10*abs(pp(i)) FreqPhase(j:length(FreqPhase))];
         if real(pp(i)) < 0
            // Pole stable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)+1 PentePhase(j:length(PentePhase))+1]; 
         else
            // Pole instable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)-1 PentePhase(j:length(PentePhase))-1]; 
         end;
      else
         // Pole multiple : on ne rajoute pas de nouvelle cassure, on ne fait qu'augmenter la pente
         if real(pp(i)) < 0
            // Pole stable
            PentePhase=[PentePhase(1:j-1)  PentePhase(j:length(PentePhase))+1]; 
         else
            // Pole instable
            PentePhase=[PentePhase(1:j-1)  PentePhase(j:length(PentePhase))-1]; 
         end;
         
      end;
   end;
   
   // Prise en compte des zeros
   for i=1:length(zz)
      j=1;
      while (FreqPhase(j)<abs(zz(i))/10)&(j<length(FreqPhase)) 
         j=j+1;
      end;
      if FreqPhase(j)~=abs(zz(i))/10
         // Zero inexistant
         FreqPhase=[FreqPhase(1:j-1) abs(zz(i))/10 FreqPhase(j:length(FreqPhase))];
         if real(zz(i)) < 0
            // Zero stable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)+1 PentePhase(j:length(PentePhase))+1]; 
         else
            // Zero instable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)-1 PentePhase(j:length(PentePhase))-1]; 
         end;
      else
         if real(zz(i)) < 0
            // Zero stable
            PentePhase=[PentePhase(1:j-1)  PentePhase(j:length(PentePhase))+1]; 
         else
            // Zero instable
            PentePhase=[PentePhase(1:j-1)  PentePhase(j:length(PentePhase))-1]; 
         end;
      end;
      
      j=1;
      while (FreqPhase(j)<abs(zz(i))*10)&(j<length(FreqPhase)) 
         j=j+1;
      end;
      if FreqPhase(j)~=abs(zz(i))*10
         // Zero inexistant
         FreqPhase=[FreqPhase(1:j-1) 10*abs(zz(i)) FreqPhase(j:length(FreqPhase))];
         if real(zz(i)) < 0
            // Zero stable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)-1 PentePhase(j:length(PentePhase))-1]; 
         else
            // Zero instable
            PentePhase=[PentePhase(1:j-1) PentePhase(j-1)+1 PentePhase(j:length(PentePhase))+1]; 
         end;
      else
         // Zero multiple : on ne rajoute pas de nouvelle cassure, on ne fait qu'augmenter la pente
         if real(zz(i)) < 0
            // Zero stable
            PentePhase=[PentePhase(1:j-1) PentePhase(j:length(PentePhase))-1]; 
         else
            // Zero instable
            PentePhase=[PentePhase(1:j-1)  PentePhase(j:length(PentePhase))+1]; 
         end;
      end;
   end;
   // ======================================================
   // Calcul des assymptotes
   // ======================================================
         
   // Initialisation : prise en compte des integrateurs
   Xgain=Wmin;
   Ygain=-20*(NbInte-NbDeriv)*log10(Wmin)+20*log10(abs(GainStatique));

   for i=1:length(FreqGain)-1
      Xgain(i+1)=FreqGain(i+1);
      if PenteGain(i)~=0
          Ygain(i+1)=Ygain(i)+20*PenteGain(i)*log10(Xgain(i+1)/Xgain(i));
      else
          Ygain(i+1)=Ygain(i);
      end;
   end;
   
   Xphase=Wmin;
   Yphase=-90*(NbInte-NbDeriv)+180*(double(bool2s(real(GainStatique)<=0)));
   
   for i=1:length(FreqPhase)-1
      Xphase(i+1)=FreqPhase(i+1);
      Yphase(i+1)=Yphase(i)+45*PentePhase(i)*log10(Xphase(i+1)/Xphase(i));
   end;
   
   // Calcul de la courbe reelle
    WW=logspace(log10(Wmin/2/%pi),log10(Wmax/2/%pi),500); // Attention Wmin et Wmax sont en rad/s !!!
	[frq,rf]=repfreq(sys,WW);
	[PHASE,MAG]=phasemag(rf,'c')
	W=frq*2*%pi; // Attention W est en Hz !!!
	Mbo=MAG;
	Pbo=PHASE;
	Fbo=W;
	
  	subplot(2,1,1);
//	plot2d(Xgain,Ygain,color(Coul),logflag='ln');
//	xname('Diagramme de Bode Asymptotique');
//	xtitle('diagramme de gain', 'frequence en rad/s','Gain en dB');
//	versio = ver(); //check version scilab obsolete
    version_numbers = getversion('scilab')
    versio = version_numbers(1);
	if tr_sys==1 then
		subplot(2,1,1);
//		plot2d(Fbo,Mbo,color(Coul),logflag='ln',frameflag=0);
        if (versio > 3) then
		    plot2d(Fbo,Mbo,color(Coul),logflag='ln');
    		plot2d(Xgain,Ygain,color(Coul),logflag='ln',frameflag=0);
	    	a=gca();
		    poly1=a.children(1).children;
    		poly1.thickness = Ep1;
        	poly2=a.children(2).children;
    		poly2.thickness = Ep2;
    	else
	    	plot2d(Fbo,Mbo,2,logflag='ln');
		    plot2d(Xgain,Ygain,2,logflag='ln',frameflag=0);
        end;
	else
    	if (versio > 3) then
		    plot2d(Xgain,Ygain,color(Coul),logflag='ln');
    		a=gca();
    		poly1=a.children(1).children;
    		poly1.thickness = Ep1;
   		else
	    	plot2d(Xgain,Ygain,2,logflag='ln');
		end;
	end
	xname('Diagramme de Bode Asymptotique');
	xtitle('Diagramme de gain', 'Frequence en rad/s','Gain en dB');
	if (grid_x == 1) then
		xgrid(1);
	end;
	subplot(2,1,2);
//	plot2d(Xphase,Yphase,color(Coul),logflag='ln');
//	xtitle('diagramme de phase', 'frequence en rad/s','Phase en degres');

	if tr_sys==1 then
		subplot(2,1,2);
//		plot2d(Fbo,Pbo,color(Coul),logflag='ln',frameflag=0);	
		if (versio > 3) then
		    plot2d(Fbo,Pbo,color(Coul),logflag='ln');	
    		plot2d(Xphase,Yphase,color(Coul),logflag='ln',frameflag=0);
    		a=gca();
    		poly1=a.children(1).children;
    		poly1.thickness = Ep1;
    		
    		poly2=a.children(2).children;
    		poly2.thickness = Ep2;
   		else
	    	plot2d(Fbo,Pbo,2,logflag='ln');	
		    plot2d(Xphase,Yphase,2,logflag='ln',frameflag=0);
		end;
	else
		if (versio > 3) then
    		plot2d(Xphase,Yphase,color(Coul),logflag='ln');
	    	a=gca();
		    poly1=a.children(1).children;
    		poly1.thickness = Ep1;
		else
	    	plot2d(Xphase,Yphase,2,logflag='ln');
		end;
	end
	xtitle('Diagramme de phase', 'Frequence en rad/s','Phase en degres');

	if (grid_x == 1) then
		xgrid(1);
	end;

//	disp('GainStat', GainStatique);
//   disp('Poles',TabPoles(kk)');
//   disp('Zeros',TabZeros(kk)');
//	disp('Système ',TabSys(kk));
//	chaine=[chaine ; 'Système '+string(kk); string(TabSys(kk)); 'Gain Statique'; string(GainStatique); 'Poles'; strsubst(string(TabPoles(kk).'),'%i','i'); 'Zeros' ;  strsubst(string(TabZeros(kk).'),'%i','i') ; '/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\'];
	chaine=[chaine ; 'Système '+string(kk); pol2str(TabSys(kk).num);"-----------------------";pol2str(TabSys(kk).den); 'Gain Statique'; string(GainStatique); 'Poles'; strsubst(string(TabPoles(kk).'),'%i','i'); 'Zeros' ;  strsubst(string(TabZeros(kk).'),'%i','i') ; '/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\'];
end; // Fin du for kk=1:NbSystemes
messagebox(chaine);
endfunction
