/////////////////////////////////////////////////////////////////////////////
////////////   ETUDE DES SYSTEMES LINEAIRES CONTINUS  ///////////////////////
/////////////////////////////////////////////////////////////////////////////
////////////    Yann MORERE 2004-2011 ///////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
////////////   INTERFACE   ////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

//figure initiale
f = figure("Position",[50 50 610 600],...
     "BackgroundColor",[0.9 0.9 0.9]);

funcprot(0); //functions protection mode evite les messages de redéfinition de focntions

//////////////////////////////////////////////////
//menu du programme
//////////////////////////////////////////////////
//  m=uimenu(f,'label', 'Fichier');
//  mm=uimenu(f,'label', 'Caracteritiques Système');
  mmm=uimenu(f,'label', 'Exporter Figures');
  mmmm=uimenu(f,'label', 'A propos', 'callback', "a_propos()");
//  // creation des items sur le menu fichier
//  m1=uimenu(m,'label', 'Ouvrir Système', 'callback', "notimplemented()");
//  m2=uimenu(m,'label', 'Enregistrer Système', 'callback', "notimplemented()");
//  m4=uimenu(m,'label', 'Imprimer...');
//  m3=uimenu(m,'label', 'Quitter', 'callback', "close(f)");
//// creation des items sur le menu Imprimer
//  m41=uimenu(m4,'label', 'Figure Bode', 'callback', "notimplemented()");
//  m42=uimenu(m4,'label', 'Figure Bode Asymptotique', 'callback', "notimplemented()");
//  m43=uimenu(m4,'label', 'Figure Nyquist', 'callback', "notimplemented()");
//  m44=uimenu(m4,'label', 'Figure Black', 'callback', "notimplemented()");
//  m45=uimenu(m4,'label', 'Figure Rep. Impulsion', 'callback', "notimplemented()");
//  m46=uimenu(m4,'label', 'Figure Rep. Echelon', 'callback', "notimplemented()");
//  m47=uimenu(m4,'label', 'Figure Rep. Rampe', 'callback', "notimplemented()");
//  m48=uimenu(m4,'label', 'Figure Rep. Parabole', 'callback', "notimplemented()");
//  m49=uimenu(m4,'label', 'Figure Placement pole/racines', 'callback', "notimplemented()");
//  m410=uimenu(m4,'label', 'Figure Lieu Evans', 'callback', "notimplemented()");
//  
//
//// creation des items sur le menu Carac
//  mm1=uimenu(mm,'label', 'Gain, Poles et Zeros','callback', "notimplemented()");
//  mm2=uimenu(mm,'label', 'Marge de Gain/Phase','callback', "notimplemented()");
//  mm2=uimenu(mm,'label', 'Stabilite BF en reponse echelon','callback', "notimplemented()");
  // creation des items sur le menu Exporter
  mmm1=uimenu(mmm,'label', 'Export Bode Figure to ...','callback', "myexportUI(11)");
  mmm2=uimenu(mmm,'label', 'Export Figure Bode Asymptotique to ...','callback', "myexportUI(1)");
  mmm3=uimenu(mmm,'label', 'Export Figure Nyquist to ...','callback', "myexportUI(2)");
  mmm4=uimenu(mmm,'label', 'Export Figure Black to ...','callback', "myexportUI(3)");
  mmm5=uimenu(mmm,'label', 'Export Figure Rep. Impulsion to ...','callback', "myexportUI(4)");
  mmm6=uimenu(mmm,'label', 'Export Figure Rep. Echelon to ...','callback',  "myexportUI(5)");
  mmm7=uimenu(mmm,'label', 'Export Figure Rep. Rampe to ...','callback', "myexportUI(6)");
  mmm8=uimenu(mmm,'label', 'Export Figure Rep. Parabole to ...','callback',  "myexportUI(7)");
  mmm9=uimenu(mmm,'label', 'Export Figure Placement pole/racines to ...','callback',  "myexportUI(8)");
  mmm10=uimenu(mmm,'label', 'Export Figure Lieu Evans to ...','callback',  "myexportUI(9)");

//////////////////////////////////////////////////
//bouton et autre widgets
//////////////////////////////////////////////////
//titre
//	titre = uicontrol( f, 'style','text', 'string','Etude des systèmes lineaires continus','position',[100 520 500 100], 'fontsize',20, 'fontweight', 'bold', "BackgroundColor",[1 1 1]);

 frame_titre= uicontrol(f, "Position"  , [5 560 600 30],...
		 "Style"     , "frame",...
		 "BackgroundColor",[0.8 0.8 0.8]);

 text_titre = uicontrol(f, "Position"  , [150 565 450 20],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "<font size=+2><b>Etude des systèmes lineaires continus</b></font>");  

// Constante à fixer
list_item = ["Boucle Ouverte"  "Boucle Fermee (Ret. Unit.)"];
initial=strcat(list_item,'|');

//Les controles de l'interface

  frame_type_systeme= uicontrol(f, "Position"  , [10 475 170 70],...
		 "Style"     , "frame",...
		 "BackgroundColor",[0.8 0.8 0.8]);

  text_type_systeme = uicontrol(f, "Position"  , [15 520 155 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "Système en :");  


  type_sys = uicontrol(f, "Position"  , [20 480 150 35],...
		 "Style"     , "listbox",...
		 "String"    ,  initial,...
		 "BackgroundColor",[1 1 1]);       

  b_bode = uicontrol(f, "Position"  , [20 440 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Bode",...
		 "callback"  , "trace_bode()" );  

  frame_bode_asympt= uicontrol(f, "Position"  , [10 395 220 40],...
		 "Style"     , "frame",...
		 "BackgroundColor",[0.8 0.8 0.8]);

  b_bode_asympt = uicontrol(f, "Position"  , [20 400 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Bode Asymptotique",...
		 "callback"  , "trace_bode_asympt()" );  

  radio_sys_reel = uicontrol(f, "Position"  , [190 400 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8]);  
  text_sys_reel = uicontrol(f, "Position"  , [175 415 50 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "Sys.reel");  

  b_nyquist = uicontrol(f, "Position"  , [20 360 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Nyquist",...
		 "callback"  , "trace_nyquist()" );  

  b_black = uicontrol(f, "Position"  , [20 320 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Black",...
		 "callback"  , "trace_black()" );  

  b_pulse = uicontrol(f, "Position"  , [20 280 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Rep. Inpulsion",...
		 "callback"  , "trace_pulse()" );  

  b_step = uicontrol(f, "Position"  , [20 240 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Rep. Echelon",...
		 "callback"  , "trace_step()" );  

  b_ramp = uicontrol(f, "Position"  , [20 200 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Rep. Rampe",...
		 "callback"  , "trace_ramp()" );  

  b_parabol = uicontrol(f, "Position"  , [20 160 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Rep. Parabole",...
		 "callback"  , "trace_parabol()" );  

  b_racine = uicontrol(f, "Position"  , [20 120 150 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Placement racines",...
		 "callback"  , "trace_racine()" );  

  frame_lieu= uicontrol(f, "Position"  , [10 10 200 90],...
		 "Style"     , "frame",...
		 "BackgroundColor",[0.8 0.8 0.8]);

  b_evans = uicontrol(f, "Position"  , [20 60 100 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Lieu Racines",...
		 "callback"  , "trace_evans()" );  

  radio_kpos = uicontrol(f, "Position"  , [140 75 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8]);  
  text_radio_kpos = uicontrol(f, "Position"  , [160 75 20 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "k>0");  

  b_calc_k = uicontrol(f, "Position"  , [20 20 100 30],...
		 "Style"     , "pushbutton",...
		 "String"    , "Calcul de k",...
		 "callback"  , "calc_k()" );  


  radio_kneg = uicontrol(f, "Position"  , [140 60 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8]);  
  text_radio_kneg = uicontrol(f, "Position"  , [160 60 20 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "k<0");  

  radio_kmax = uicontrol(f, "Position"  , [140 45 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8]);  
  text_radio_kmax = uicontrol(f, "Position"  , [160 45 35 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "k max.");  
  edit_kmax = uicontrol(f, "Position"  , [160 20 40 25],...
 		 "Style"     , "edit",...
 		 "String"    , "100",...
 		 "BackgroundColor",[1 1 1]);


  frame_lieu_vector= uicontrol(f, "Position"  , [240 480 350 75],...
		 "Style"     , "frame",...
		 "BackgroundColor",[0.8 0.8 0.8]);
  radio_vector = uicontrol(f, "Position"  , [250 530 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "callback", "gere_vector()");  
  text_radio_vector = uicontrol(f, "Position"  , [270 530 170 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "Vecteur des coefficients en s");  
  text2_radio_vector = uicontrol(f, "Position"  , [250 490 230 40],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "$H=\textrm{tf}([1\quad 1],[1\quad 2\quad 1])=\frac{s+1}{s^2+2.s+1}$");  //LaTeX in GUI

  frame_lieu_poly= uicontrol(f, "Position"  , [240 400 350 75],...
		 "Style"     , "frame",...
		 "BackgroundColor",[0.8 0.8 0.8]);
  radio_poly = uicontrol(f, "Position"  , [250 450 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "callback", "gere_poly()");  
  text_radio_poly = uicontrol(f, "Position"  , [270 450 150 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "Polynome en s");  
  text2_radio_poly = uicontrol(f, "Position"  , [250 410 230 40],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "$G=\textrm{tf}((s+1)/(s^2+2.s+1))=\frac{s+1}{s^2+2.s+1}$");  

//		 "String"    , "                                  s+1\nG=tf\(\(1+p\)/\(s^2+2*s+1\)\)  = ---------------\n                                   s^2+2*s+1");  

  text_num_gene_sys = uicontrol(f, "Position"  , [240 370 350 20],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.1 0.9 0.1],...
		 "fontweight", "bold",...
		 "String"    , "Fonction de transfert du système (en s)");  
  text_num_gene2_sys = uicontrol(f, "Position"  , [240 330 350 40],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.1 0.9 0.9],...
		 "fontangle", "oblique",...
		 "fontweight", "demi",...
		 "String"    , "Coefficients par odre de puissance croissante<br>separes par des espaces : 2 1 3 pour 2+1*s+3*s^2");  

  text_num_sys = uicontrol(f, "Position"  , [240 310 150 20],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.9 0.9 0.9],...
		 "fontweight", "normal",...
		 "String"    , "Numerateur de G(s)");  

  text_den_sys = uicontrol(f, "Position"  , [440 310 150 20],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.9 0.9 0.9],...
		 "fontweight", "normal",...
		 "String"    , "Denominateur de G(s)");  

  edit_num_sys = uicontrol(f, "Position"  , [240 280 170 25],...
 		 "Style"     , "edit",...
 		 "String"    , "",...
 		 "BackgroundColor",[1 1 1]);

  edit_den_sys = uicontrol(f, "Position"  , [420 280 170 25],...
 		 "Style"     , "edit",...
 		 "String"    , "",...
 		 "BackgroundColor",[1 1 1]);

  text_num_gene_cor = uicontrol(f, "Position"  , [240 250 350 20],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.1 0.9 0.1],...
		 "fontweight", "bold",...
		 "String"    , "Fonction de transfert du correcteur (en s)");  
  text_num_gene2_cor = uicontrol(f, "Position"  , [240 210 350 40],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.1 0.9 0.9],...
		 "fontangle", "oblique",...
		 "fontweight", "demi",...
		 "String"    , "Coefficients par odre de puissance croissante<br>separes par des espaces : 2 1 3 pour 2+1*s+3*s^2");  

  text_num_cor = uicontrol(f, "Position"  , [240 180 150 20],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.9 0.9 0.9],...
		 "fontweight", "normal",...
		 "String"    , "Numerateur de C(s)");  

  text_den_cor = uicontrol(f, "Position"  , [440 180 150 20],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.9 0.9 0.9],...
		 "fontweight", "normal",...
		 "String"    , "Denominateur de C(s)");  


  edit_num_cor = uicontrol(f, "Position"  , [240 150 170 25],...
 		 "Style"     , "edit",...
 		 "String"    , "1",...
 		 "BackgroundColor",[1 1 1]);

  edit_den_cor = uicontrol(f, "Position"  , [420 150 170 25],...
 		 "Style"     , "edit",...
 		 "String"    , "1",...
 		 "BackgroundColor",[1 1 1]);

  frame_courbe_temps= uicontrol(f, "Position"  , [240 10 350 130],...
		 "Style"     , "frame",...
		 "BackgroundColor",[0.8 0.8 0.8]);

  check_gridx = uicontrol(f, "Position"  , [250 40 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8]);  

  text_check_gridx = uicontrol(f, "Position"  , [270 40 120 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "Quadrillage normal ");  


  check_grids = uicontrol(f, "Position"  , [250 20 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8]);  

  text_check_grids = uicontrol(f, "Position"  , [270 20 165 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "Quadrillage plan complexe ");  

//  b_redraw = uicontrol(f, "Position"  , [320 20 100 30],...
//		 "Style"     , "pushbutton",...
//		 "String"    , "Retrace",...
//		 "callback"  , "retrace()" );  

  check_intervalle = uicontrol(f, "Position"  , [250 120 15 15],...
		 "Style"     , "checkbox",...
		 "Min"	,0,...
		 "Max"	,1,...
		 "BackgroundColor",[0.8 0.8 0.8]);  

  text_check_intervalle = uicontrol(f, "Position"  , [270 120 300 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "Intervalle de trace (seulement fonctions temporelles)");  

  text_edit_xmin = uicontrol(f, "Position"  , [260 100 70 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "x min.");  

  edit_xmin = uicontrol(f, "Position"  , [260 70 70 25],...
 		 "Style"     , "edit",...
 		 "String"    , "0",...
 		 "BackgroundColor",[1 1 1]);

  text_edit_xmax = uicontrol(f, "Position"  , [340 100 70 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "x max.");  

  edit_xmax = uicontrol(f, "Position"  , [340 70 70 25],...
 		 "Style"     , "edit",...
 		 "String"    , "20",...
 		 "BackgroundColor",[1 1 1]);

  text_edit_ymin = uicontrol(f, "Position"  , [420 100 70 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "y min.");  

  edit_ymin = uicontrol(f, "Position"  , [420 70 70 25],...
 		 "Style"     , "edit",...
 		 "String"    , "0",...
 		 "BackgroundColor",[1 1 1]);

  text_edit_ymax = uicontrol(f, "Position"  , [500 100 70 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "y max.");  

  edit_ymax = uicontrol(f, "Position"  , [500 70 70 25],...
 		 "Style"     , "edit",...
 		 "String"    , "10",...
 		 "BackgroundColor",[1 1 1]);

  text_edit_pas = uicontrol(f, "Position"  , [485 50 100 15],...
		 "Style"     , "text",...
		 "BackgroundColor",[0.8 0.8 0.8],...
		 "String"    , "pas (defaut 0.05)");  

  edit_pas = uicontrol(f, "Position"  , [500 20 70 25],...
 		 "Style"     , "edit",...
 		 "String"    , "0.05",...
 		 "BackgroundColor",[1 1 1]);


////////////////////////////////////////////////////////////////////////////
///////////    Initialisation de l'interface     ///////////////////////////
////////////////////////////////////////////////////////////////////////////

//Initialisation au demarrage
set(radio_vector,'Value',1);
set(radio_kpos,'Value',1);
set(type_sys,'Value',1);
set(check_gridx,'Value',1);
set(check_grids,'Value',0);
set(check_intervalle,'Value',0);

////////////////////////////////////////////////////////////////////////////
///////////    Initialisation du programme       ///////////////////////////
////////////////////////////////////////////////////////////////////////////

//mettre la definition du polynome ici
//juste avant dans les fonctions il y a redefinition et cela ne marche pas
s=poly(0,"s");
// chargement de fonction scilab modifiée pour l'occasion 
// (surtout pour l'affichage et francisation)

exec('bode_asymp.sci',-1);

////////////////////////////////////////////////////////////////////////////
///////////  Fonction de gestion de l'interface  ///////////////////////////
////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////
// Fonction de gestion des paramètres de l'interface

function [G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas, saisie_ok]=recup_valeur()
	saisie_ok=1;
	t_sys=get(type_sys, 'value');
	kpos=get(radio_kpos, 'value');
	kneg=get(radio_kneg, 'value');
	rkmax=get(radio_kmax, 'value');
	k_max=get(edit_kmax, 'string');
	kmax=evstr(k_max);
	sysreel=get(radio_sys_reel, 'value');
	num_sys=get(edit_num_sys,'string');
	den_sys=get(edit_den_sys,'string');
	num_cor=get(edit_num_cor,'string');
	den_cor=get(edit_den_cor,'string');
	vec=get(radio_vector, 'value');
	pol=get(radio_poly, 'value');
	gridx=get(check_gridx, 'value');
	grids=get(check_grids, 'value');
	intervalle=get(check_intervalle, 'value');
	if (intervalle==1) then
		x_min=get(edit_xmin,'string');
		xmin=evstr(x_min);
		x_max=get(edit_xmax,'string');
		xmax=evstr(x_max);
		y_min=get(edit_ymin,'string');
		ymin=evstr(y_min);
		y_max=get(edit_ymax,'string');
		ymax=evstr(y_max);
		p_pas=get(edit_pas,'string');
		pas=evstr(p_pas);
	else
		xmin=0;
		xmax=0;
		ymin=0;
		ymax=0;
		pas=0.05;	
	end;	

	// disp('t_sys',t_sys);
	// disp('kpos',kpos);
	// disp('kneg',kneg);
	// disp('num_sys',evstr(num_sys));
	// disp('den_sys',den_sys);
	// disp('num_cor',num_cor);
	// disp('den_cor',den_cor);
	// disp('vec',vec);
	// disp('pol',pol);

	if (isempty(num_sys) | isempty(den_sys) | isempty(num_cor) | isempty(den_cor)) then
	saisie_ok=0;
	messagebox(['Système / Correcteur' ; 'Une des entrées (Numérateur/Dénominateur) est vide']);
	G=[]; C=[]; //pour éviter qu'ils soient pas défini pour le retour de la fonction
	else
		if (vec == 1) then
		//coeff
			G=syslin('c', poly(evstr(num_sys),"s","coeff"), poly(evstr(den_sys),"s","coeff"));
			C=syslin('c', poly(evstr(num_cor),"s","coeff"), poly(evstr(den_cor),"s","coeff"));
		else
		//poly
			G=syslin('c',evstr(num_sys),evstr(den_sys));
			C=syslin('c',evstr(num_cor),evstr(den_cor));
		end
	end;
	//disp(G);
	//disp(C);
	//disp((G*C)/.(1)) //mettre les parenthèses sinon faux
endfunction

/////////////////////////////////////////////////////////////////
// Nouvelle Fonction sgrid par défaut avec passage de la couleur
// finction obsolete
function sgrid2(couleur)
wn = 0:1:10;
zeta = [ 0 .1 .2 .3 .4 .5 .6 .7 .8 .9 1 ];
sgrid(zeta,wn,couleur);
endfunction

/////////////////////////////////////////////////////////////////
// Pour savoir qui a programmé

function a_propos()
	messagebox(['Réalisé avec Scilab par Y. Morère 2004';''; 'Merci à S. Delprat' ; 'pour la fonction Matlab tracebode()'])
endfunction

/////////////////////////////////////////////////////////////////
// Check présence fenêtre graphique

// fonction qui test si le fenêtre graphique numfen est presente
// dans le bureau
function ok_g=test_graphique(numfen)
ok_g=0;
if (sum(bool2s(winsid() == numfen))==1) then
	ok_g=1;
end
endfunction

/////////////////////////////////////////////////////////////////
// raise and focus fenêtre graphique

// fonction qui met au premier plan une fenêtre graphique et lui donne le focus

function raiseandfocus(numfen)
    if (sum(bool2s(winsid() ==numfen))==1) then //test existance fenêtre
        show_window(numfen); //mise au premier plan
	    clf(numfen); //effecement graphique
        scf(numfen); //donne le focus à la figure
    else
        show_window(numfen);
        scf(numfen);
    end
endfunction

/////////////////////////////////////////////////////////////////
// Fonction d'exportation des graphiques

function myexportUI(numfen)
if (test_graphique(numfen)) then
	exportUI(numfen)
else
    messagebox('Pas de Figure pour l''exportation ');
end
endfunction
 

/////////////////////////////////////////////////////////////////
// Fonction d'exportation des graphiques
// fonction obsolete
function export(type_figure, type_export) 
// test si la figure est ouverte
if ~(test_graphique(type_figure)) then
	messagebox('Pas de Figure pour l''exportation ');
else
	 select (type_figure),
	   case 11 then fig='bode',
	   case 1 then fig='bode_asymptotique',
	   case 2 then fig='nyquist',
	   case 3 then fig='black',
	   case 4 then fig='impulsion',
	   case 5 then fig='echelon',
	   case 6 then fig='rampe',
	   case 7 then fig='parabole',
	   case 8 then fig='racines',
	   case 9 then fig='evans',
       else fig='bof',
	 end

	 select type_export,
	   case 0 then style = 'XFig', extent='.fig',
	   case 1 then style = 'Gif', extent='.gif',
	   case 2 then style = 'Ppm', extent='.ppm',
	   case 3 then style = 'Ps', extent='.ps',
	   case 4 then style = 'Scilab', extent='.scg',
	   case 5 then style = 'Eps', extent='.eps',
	   case 6 then style = 'Eps/LaTeX', extent='.eps',
       else style = 'Inconnu', extent='.inc',
	 end
	str=pwd();
    disp(fig);
    disp(style,extent);
	if MSDOS then
		path=uigetfile('*'+extent,str+'\'+fig+extent,'Exporter '+style);
	else
		path=uigetfile('*'+extent,str+'/'+fig+extent,'Exporter '+style);
	end;	
	if ~(isempty(path)) then
	 select type_export,
	   case 0 then xs2fig(type_figure,path,'portrait'),
	   case 1 then xs2gif(type_figure,path),
	   case 2 then xs2ppm(type_figure,path),
	   case 3 then xs2ps(type_figure,path,'portrait'), 
	   				if MSDOS then
						strsci=strsubst(SCI,'/','\');
						cmd='copy '+strsci+'\imp\NperiPos.ps + '+path+' '+path+'.tmp',[rep,stat]=unix_g(cmd), cmd='move /Y '+path+'.tmp '+path, [rep,stat]=unix_g(cmd), //disp(cmd,path,rep,stat);
	   				else
	   					cmd='cat '+SCI+'/imp/NperiPos.ps '+path+' > '+path+'.tmp; mv '+path+'.tmp '+path, [rep,stat]=unix_g(cmd),
	   				end
	   case 4 then xsave(path,type_figure),
	   case 5 then xs2ps(type_figure,path,1), 
					if MSDOS then
						strsci=strsubst(SCI,'/','\');
						cmd='copy '+strsci+'\imp\NperiPos.ps + '+path+' '+path+'.tmp',[rep,stat]=unix_g(cmd), cmd='move /Y '+path+'.tmp '+path, [rep,stat]=unix_g(cmd), cmd=strsci+'/bin/BEpsf '+path, [rep,stat]=unix_g(cmd), cmd='del '+path+'.temp', [rep,stat]=unix_g(cmd), //disp(cmd,path,rep,stat);
					else
						cmd='cat '+SCI+'/imp/NperiPos.ps '+path+' > '+path+'.tmp; mv '+path+'.tmp '+path+' ; '+SCI+'/bin/BEpsf '+path+'; rm '+path+'.temp', [rep,stat]=unix_g(cmd), //disp(cmd,path,rep,stat);

					end;
	   case 6 then 
					if MSDOS then
						xs2ps(type_figure,path,1), 
						strsci=strsubst(SCI,'/','\');
						cmd='copy '+strsci+'\imp\NperiPos.ps + '+path+' '+path+'.tmp',[rep,stat]=unix_g(cmd), cmd='move /Y '+path+'.tmp '+path, [rep,stat]=unix_g(cmd), cmd=strsci+'/bin/Blatexpr 1.0 1.0 '+path, [rep,stat]=unix_g(cmd), cmd='del '+path+'.temp', [rep,stat]=unix_g(cmd), //disp(cmd,path,rep,stat);
					else
						xs2ps(type_figure,path,1), 
						cmd='cat  '+SCI+'/imp/NperiPos.ps '+path+' > '+path+'.tmp; mv '+path+'.tmp '+path+' ; '+SCI+'/bin/Blatexpr 1.0 1.0 '+path+'; rm '+path+'.temp', [rep,stat]=unix_g(cmd), //disp(cmd,path,rep,stat);
					end
	 end
	xinfo('Export sous '+path);
	end;
end;
endfunction

/////////////////////////////////////////////////////////////////
// Pouir les Fonctions par encore implémentée

function notimplemented()
	messagebox(['Fonction pas encore implémentée, désolé!'; 'Peut être pouvez-vous passer par le menu de la fenêtre graphique...'])
endfunction

/////////////////////////////////////////////////////////////////
// Fonctions de gestion de passage et conversion de fonction
// de transfrt sous forme Polynôme <--> vecteur

function gere_vector()
	set(radio_vector,'Value',1);
	set(radio_poly,'Value',0);
	set(text_num_gene2_sys, 'String',"Coefficients par odre de puissance croissante<br>separes par des espaces : 2 1 3 pour 2+1*s+3*s^2");
	set(text_num_gene2_cor, 'String',"Coefficients par odre de puissance croissante<br>separes par des espaces : 2 1 3 pour 2+1*s+3*s^2");

	num_sys=get(edit_num_sys,'string');
	den_sys=get(edit_den_sys,'string');
	num_cor=get(edit_num_cor,'string');
	den_cor=get(edit_den_cor,'string');

	if (isempty(num_sys) | isempty(den_sys) | isempty(num_cor) | isempty(den_cor)) then
	G=[]; C=[]; //pour éviter qu'ils soient pas défini pour le retour de la fonction
	else
		//poly
			G=syslin('c',evstr(num_sys),evstr(den_sys));
			C=syslin('c',evstr(num_cor),evstr(den_cor));
	end;
	if ~(isempty(G)) then
		nnum='';  //obligé de construire la chaine de caractère 
		for i=coeff(G.num),	//string(coeff(G.num)) ne donne pas une chaine valide
			nnum=nnum+' '+string(i);
		end	
		set(edit_num_sys,'String', nnum);

		dden='';
		for i=coeff(G.den),
			dden=dden+' '+string(i);
		end		
		set(edit_den_sys,'String', dden);
	end;
	if ~(isempty(C)) then
		nnum='';
		for i=coeff(C.num),
			nnum=nnum+' '+string(i);
		end	
		set(edit_num_cor,'String', nnum);
		dden='';
		for i=coeff(C.den),
			dden=dden+' '+string(i);
		end		
		set(edit_den_cor,'String', dden);
	end
endfunction

function gere_poly()
	set(radio_vector,'Value',0);
	set(radio_poly,'Value',1);
	set(text_num_gene2_sys, 'String',"Polynôme en s : 2+1*s+3*s^2");
	set(text_num_gene2_cor, 'String',"Polynôme en s : 2+1*s+3*s^2");

	num_sys=get(edit_num_sys,'string');
	den_sys=get(edit_den_sys,'string');
	num_cor=get(edit_num_cor,'string');
	den_cor=get(edit_den_cor,'string');

	if (isempty(num_sys) | isempty(den_sys) | isempty(num_cor) | isempty(den_cor)) then
	G=[]; C=[]; //pour éviter qu'ils soient pas défini pour le retour de la fonction
	else
		//coeff
			G=syslin('c', poly(evstr(num_sys),"s","coeff"), poly(evstr(den_sys),"s","coeff"));
			C=syslin('c', poly(evstr(num_cor),"s","coeff"), poly(evstr(den_cor),"s","coeff"));

	end;
	if ~(isempty(G)) then
		set(edit_num_sys,'String', string(pol2str(G.num)));
		set(edit_den_sys,'String', string(pol2str(G.den)));
	end;
	if ~(isempty(C)) then
		set(edit_num_cor,'String', string(pol2str(C.num)));
		set(edit_den_cor,'String', string(pol2str(C.den)));
	end

endfunction

/////////////////////////////////////////////////////////////////
// Fonction de retraçage des graphique pas utilisée ni finalisée
// fonction pas utilisée
function retrace()
[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
	if (gridx==1) then
		xgrid()
	end;
	xbasr();
	// faire un suivi des boutons cliquer pour avoir la dernière figure tracee
	//ou encore recupere le ficure active et voir ce q'il y a dedans
	// utilisation de [wrect,frect,logflag,arect]=xgetech() et xsetech([0,0,1.0,0.5])
endfunction

////////////////////////////////////////////////////////////////////////////
///////////   Gestion des traces d'automatique   ///////////////////////////
////////////////////////////////////////////////////////////////////////////

// Gestion des traces d'automatique

function trace_bode()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(11);

	if (t_sys == 1) then    
        H = G*C;
    else
        H = (G*C)/.(1);
    end
    disp(G,H);
    //pôles et zéros
    zz = roots(H.num);
    pp = roots(H.den);
    disp(pp,zz);
    
   // Recherche des bornes
   if (~isempty(pp))&(isempty(zz)) then
       // Que des poles
       Wmin=min(abs(pp));
       Wmax=max(abs(pp));
   elseif (~isempty(zz))&(isempty(pp)) then
       // Que des zeros
       Wmin=min(abs(zz));
       Wmax=max(abs(zz));
   elseif (isempty(zz))&(isempty(pp)) then
       // Que des integrateurs ou des gains
       Wmin=1;
       Wmax=1;
   else
       // Poles et zeros
       Wmin=min(abs(max(abs(zz))),abs(max(abs(pp))));
       Wmax=max(abs(min(abs(zz))),abs(min(abs(pp))));
   end;
   disp(Wmin);
   disp(Wmax);

   if (Wmin==0) then
       WWmin = 0.01
   else
       // Arrondis à la puissance de 10
       WWmin=10^(floor(log10(Wmin))-2) //2 décades avant
   end
   if (Wmax==0) then
       WWmax = 100
   else
       // Arrondis à la puissance de 10
       WWmax=10^(floor(log10(Wmax))+2) //2 décades avant
   end
    
   // Arrondis à la puissance de 10
//   WWmin=10^(floor(log10(Wmin))-2); //2 décades avant
//   WWmax=10^(ceil(log10(Wmax))+2); //2 décades après
   //Attention W en rad/s -> Hz pour scilab
   WWmin=WWmin/(2*%pi); 
   WWmax=WWmax/(2*%pi); 
   
  disp(WWmin);
  disp(WWmax);
      //la fig 0 est celle du logiciel
	if (t_sys == 1) then
		bode(G*C, WWmin, WWmax);
		xname('Diagramme de Bode en BO');
		[mPhase,freqp]=p_margin(G*C);
		[mGain,freqg]=g_margin(G*C);
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp)+'Hz';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg)+'Hz']);
	else
		bode((G*C)/.(1)); //fonction feedback avec retour unitaire (1)
		xname('Diagramme de Bode en BF');
		[mPhase,freqp]=p_margin((G*C)/.(1));
		[mGain,freqg]=g_margin((G*C)/.(1));
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp)+'Hz';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg)+'Hz']);
	end
end
endfunction

function trace_bode_asympt()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(1);
	if (t_sys == 1) then
		if (sysreel==1) then
			bode_asymp(G*C,'blue',3,1,1,gridx);
		else
			bode_asymp(G*C,'blue',3,1,0,gridx);
		end;
		xname('Diagramme de Bode en BO');
		[mPhase,freqp]=p_margin(G*C);
		[mGain,freqg]=g_margin(G*C);
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp*2*%pi)+'rad/s';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg*2*%pi)+'rad/s']);
	else
		if (sysreel==1) then
			bode_asymp((G*C)/.(1),'blue',3,1,1,gridx); //fonction feedback avec retour unitaire (1)
		else
			bode_asymp((G*C)/.(1),'blue',3,1,0,gridx); //fonction feedback avec retour unitaire (1)
		end;
		xname('Diagramme de Bode en BF');
		[mPhase,freqp]=p_margin((G*C)/.(1));
		[mGain,freqg]=g_margin((G*C)/.(1));
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp*2*%pi)+'rad/s';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg*2*%pi)+'rad/s']);
	end
end
endfunction


function trace_nyquist()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(2);
	if (t_sys == 1) then
		nyquist(G*C);
		xname('Diagramme de Nyquist en BO');
		if (gridx == 1) then
			xgrid();
		end
		[mPhase,freqp]=p_margin(G*C);
		[mGain,freqg]=g_margin(G*C);
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp)+'Hz';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg)+'Hz']);
	else
		nyquist((G*C)/.(1)); //fonction feedback avec retourt unitaire
		xname('Diagramme de Nyquist en BF');
		if (gridx == 1) then
			xgrid();
		end
		[mPhase,freqp]=p_margin((G*C)/.(1));
		[mGain,freqg]=g_margin((G*C)/.(1));
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp)+'Hz';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg)+'Hz']);
	end
end
endfunction

function trace_black()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(3);

	if (t_sys == 1) then
		black(G*C);
		xname('Diagramme de Black en BO');
		if (gridx == 1) then
			xgrid();
		end
		[mPhase,freqp]=p_margin(G*C);
		[mGain,freqg]=g_margin(G*C);
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp)+'rad/s';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg)+'rad/s']);
	else
		black((G*C)/.(1));
		xname('Diagramme de Black en BF');
		if (gridx == 1) then
			xgrid(); 
		end
		[mPhase,freqp]=p_margin((G*C)/.(1));
		[mGain,freqg]=g_margin((G*C)/.(1));
		if (mPhase < 0) then
			mPhase=-(-180-mPhase);
		else
			mPhase=mPhase-180;
		end
		messagebox(['Marge de phase : '+string(mPhase)+'°, à '+string(freqp)+'Hz';'Marge de gain : '+string(mGain)+'dB, à '+string(freqg)+'Hz']);
	end
end
endfunction

function trace_pulse()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(4);
	if (intervalle==1) then
		t=xmin:pas:xmax;
	else
		t=0:0.05:5;
	end;
	//impulse(w) = step (s * w)
	if (t_sys == 1) then
//		disp('intervalle',intervalle);
		if (intervalle==1) then
			plot2d(t',(csim('step',t,s*(G*C)))',2,leg="Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]);
		else
		plot2d(t',(csim('step',t,s*(G*C)))',2,"161","Reponse");
		end;
//		plot2d([t',t'],[(csim('step',t,tf2ss(s)*(G*C)))',0*t']);
		xname('Reponse temporelle Impulsion en BO');
		if (gridx == 1) then
			xgrid(); 
		end
	else

//		plot2d([t',t'],[(csim('step',t,tf2ss(s)*((G*C)/.(1))))',0*t']);
		if (intervalle==1) then
			plot2d(t',(csim('step',t,s*((G*C)/.(1))))',2,leg="Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]);
		else
		plot2d(t',(csim('step',t,s*((G*C)/.(1))))',2,"161","Reponse");
		end;
//		plot2d(t',(csim('step',t,s*((G*C)/.(1))))',2,"161","Reponse");
		xname('Reponse temporelle Impulsion en BF');
		if (gridx == 1) then
			xgrid(); 
		end
	end	
end
endfunction

function trace_step()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(5);
	if (intervalle==1) then
		t=xmin:pas:xmax;
	else
		t=0:0.05:5;
	end;
	[nr,nc]=size(t);
	ech=ones(1,nc);
	//impulse(w) = step (s * w)
	if (t_sys == 1) then
//		plot2d([t',t'],[(csim('step',t,(G*C)))',0*t']);
		if (intervalle==1) then
		plot2d(t',[ech' (csim('step',t,(G*C)))'],[2,3],leg="Consigne@Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]); 	
		else
		plot2d(t',[ech' (csim('step',t,(G*C)))'],[2,3],"161","Consigne@Reponse"); 
		end;
//		plot2d(t',[ech' (csim('step',t,(G*C)))'],[2,3],"161","Consigne@Reponse"); 
//		plot2d(t',(csim('step',t,(G*C)))',2,"161","Reponse");
		xname('Reponse temporelle Echelon en BO');
		if (gridx == 1) then
			xgrid(); 
		end
	else
//		plot2d([t',t'],[(csim('step',t,((G*C)/.(1))))',0*t']);
		if (intervalle==1) then
		plot2d(t',[ech' (csim('step',t,((G*C)/.(1))))'],[2,3],leg="Consigne@Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]); 	
		else
		plot2d(t',[ech' (csim('step',t,((G*C)/.(1))))'],[2,3],"161","Consigne@Reponse"); 
		end;
//		plot2d(t',[ech' (csim('step',t,((G*C)/.(1))))'],[2,3],"161","Consigne@Reponse");
		xname('Reponse temporelle Echelon en BF');
		if (gridx == 1) then
			xgrid();
		end
	end	
end
endfunction

function trace_ramp()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(6);
	if (intervalle==1) then
		t=xmin:pas:xmax;
	else
		t=0:0.05:5;
	end;
	ram=t;
	//ramp(w) = step (1/s * w)
	if (t_sys == 1) then
//		plot2d([t',t'],[(csim('step',t,tf2ss(1/s)*(G*C)))',0*t']);
		if (intervalle==1) then
		plot2d(t',[ram' (csim('step',t,(1/s)*(G*C)))'],[2,3],leg="Consigne@Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]); 
		else
		plot2d(t',[ram' (csim('step',t,(1/s)*(G*C)))'],[2,3],"161","Consigne@Reponse"); 
		end;
//		plot2d(t',[ram' (csim('step',t,(1/s)*(G*C)))'],[2,3],"161","Consigne@Reponse"); 
		xname('Reponse temporelle Rampe en BO');
		if (gridx == 1) then
			xgrid();
		end
	else
//		plot2d([t',t'],[(csim('step',t,tf2ss(1/s)*((G*C)/.(1))))',0*t']);
		if (intervalle==1) then
		plot2d(t',[ram' (csim('step',t,(1/s)*((G*C)/.(1))))'],[2,3],leg="Consigne@Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]); 
		else
		plot2d(t',[ram' (csim('step',t,(1/s)*((G*C)/.(1))))'],[2,3],"161","Consigne@Reponse"); 
		end;
//		plot2d(t',[ram' (csim('step',t,(1/s)*((G*C)/.(1))))'],[2,3],"161","Consigne@Reponse"); 
		xname('Reponse temporelle Rampe en BF');
		if (gridx == 1) then
			xgrid();
		end
	end	
end
endfunction

function trace_parabol()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(7);
	if (intervalle==1) then
		t=xmin:pas:xmax;
	else
		t=0:0.05:5;
	end;
	par=t.*t;
	//parabol(w) = step (1/s^2 * w)
	if (t_sys == 1) then
//		plot2d([t',t'],[(csim('step',t,tf2ss(1/s^2)*(G*C)))',0*t']);
		if (intervalle==1) then
			plot2d(t',[par' (csim('step',t,(1/s^2)*(G*C)))'],[2,3],leg="Consigne@Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]);
		else
			plot2d(t',[par' (csim('step',t,(1/s^2)*(G*C)))'],[2,3],"161","Consigne@Reponse");
		end;
//plot2d(t',[par' (csim('step',t,(1/s^2)*(G*C)))'],[2,3],"161","Consigne@Reponse");
		xname('Reponse temporelle Parabole en BO');
		if (gridx == 1) then
			xgrid();
		end
	else
//		plot2d([t',t'],[(csim('step',t,tf2ss(1/s^2)*((G*C)/.(1))))',0*t']);
		if (intervalle==1) then
			plot2d(t',[par' (csim('step',t,(1/s^2)*((G*C)/.(1))))'],[2,3],leg="Consigne@Reponse",frameflag=1,rect=[xmin,ymin,xmax,ymax]);
		else
			plot2d(t',[par' (csim('step',t,(1/s^2)*((G*C)/.(1))))'],[2,3],"161","Consigne@Reponse");
		end;
//plot2d(t',[par' (csim('step',t,(1/s^2)*((G*C)/.(1))))'],[2,3],"161","Consigne@Reponse");
		xname('Reponse temporelle Parabole en BF');
		if (gridx == 1) then
			xgrid();
		end
	end	
end
endfunction

function trace_racine()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(8);
	if (t_sys == 1) then
		plzr(G*C);
		xname('Positions Poles et Zeros en BO');
	else
		plzr((G*C)/.(1));
		xname('Positions Poles et Zeros en BF');
	end	
end
endfunction

function trace_evans()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    raiseandfocus(9);
//check du bouton kmax sinon on utilise la valeur de kmax
if (rkmax ~= 1) then
	kmax=100;
end;
//disp('kmax',kmax);
	if (kpos == 1) then
		if (t_sys == 1) then
			evans(G*C,kmax);
            sgrid() 
			xname('Lieu d''Evans en BO');
		else
			evans((G*C)/.(1),kmax);
            sgrid() 
			xname('Lieu d''Evans en BF');
		end	
	end
	if (kneg == 1) then
		if (t_sys == 1) then
			evans(-G*C,kmax);
            sgrid()    
			xname('Lieu d''Evans en BO');
		else
			evans((-G*C)/.(1),kmax);
            sgrid();
			xname('Lieu d''Evans en BF');
		end	
	end
end
endfunction


/////////////////////////////////////////////////////////////////
// Super Fonction du calcul du gain sur la courbe d'Evans

function calc_k()
	[G,C,t_sys,kpos,kneg,rkmax,kmax,gridx,grids,sysreel,intervalle,xmin,xmax,ymin,ymax,pas,saisie_ok]=recup_valeur();
if (saisie_ok==1) then
    if (sum(bool2s(winsid() == 9))==1) then
        show_window(9);
		rep=[0,0,-1];
		while rep(3)==-1 then
		   	 [rep,win]=xgetmouse()
             if (win==9) then
		         x=rep(1); y=rep(2);
    			 k=-1/real(horner((G*C),[1,%i]*[x ; y]));	
	    	    xinfo('x = '+string(x)+', y = '+string(y)+' Valeur de K = '+string(k));
             end
		end
		 k=-1/real(horner((G*C),[1,%i]*[x ; y]));	
	//	coord=locate(1);
	//	k=-1/real(horner((G*C),[1,%i]*coord));
	//	messagebox(['Coordonnees Point'; string(coord); 'Valeur de k : ';string(k)]);
		messagebox(['Coordonnees Point'; string([x ; y]); 'Valeur de k : ';string(k)]);
	else
		messagebox('Pas de tracé d''Evans pour faire le calcul');
	end;
end;
endfunction

////////////////////////////////////////////////////////////////////////////
////////////////////////       Fin               ///////////////////////////
////////////////////////////////////////////////////////////////////////////
